<?php
#!/usr/bin/php -q

global $config;

/* do NOT run this script through a web browser */
$no_http_headers = true;

/* display No errors */
error_reporting(0);

if (!isset($called_by_script_server)) {
  include_once(dirname(__FILE__) . '/../include/cli_check.php');

  array_shift($_SERVER["argv"]);

  print call_user_func_array("ss_fritzbox_waninfo", $_SERVER["argv"]);
  return;
}


function TR064Soap($url, $urn, $method='GetInfo') {
    $parameter = array(
        'location'   => $url,
        'uri'        => $urn,
        'connection_timeout' => 5
    );

    $client = new SoapClient(
        null,
        $parameter
    );
    ini_set('default_socket_timeout', 5);
    $status = $client->$method();
    ini_restore('default_socket_timeout');
    return $status;
}


function ss_fritzbox_waninfo($hostname) {

  $in = $out = $uptime = 'U';
  $port = 49000;

  try {
    $result = TR064Soap("http://$hostname:$port/igdupnp/control/WANCommonIFC1", 'urn:schemas-upnp-org:service:WANCommonInterfaceConfig:1', 'GetAddonInfos');

    $in  = isset($result['NewX_AVM_DE_TotalBytesReceived64']) ? $result['NewX_AVM_DE_TotalBytesReceived64'] : $result['NewTotalBytesReceived'];
    $out = isset($result['NewX_AVM_DE_TotalBytesSent64'])     ? $result['NewX_AVM_DE_TotalBytesSent64']     : $result['NewTotalBytesSent'];

    $result = TR064Soap("http://$hostname:$port/igdupnp/control/WANIPConn1", 'urn:schemas-upnp-org:service:WANIPConnection:1', 'GetStatusInfo');
    $uptime  = $result['NewUptime'];
  }
  catch (SoapFault $e) {
    $msg = "ERROR: unable to get upnp information via TR-0064 for hostname='$hostname' msg='" . $e->getMessage() . "'";
    if (isset($e->faultcode)) $msg .= " faultcode='" . $e->faultcode . "'";
    if ($e->getCode() == "UPnPError") {
      if (isset($e->detail) && isset($e->detail->UPnPError)) {
        $msg .= " errorCode=" . $e->detail->UPnPError->errorCode;
        $msg .= " errorDescription='" . $e->detail->UPnPError->errorDescription . "'";
      }
    }
    global $called_by_script_server;
    if (isset($called_by_script_server))
      cacti_log($msg);
    else
      print "$msg\n";
  }
  return "uptime:$uptime in:$in out:$out";
}

?>